// **********************************************************************
//
// Copyright (c) 2003-2006 ZeroC, Inc. All rights reserved.
//
// This copy of Ice-E is licensed to you under the terms described in the
// ICEE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice-E version 1.1.0

package Demo;

public abstract class _HelloDisp extends Ice.ObjectImpl implements Hello
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
	throws IceUtil.CloneException
    {
	throw new IceUtil.CloneException();
    }

    public static final String[] __ids =
    {
	"::Demo::Hello",
	"::Ice::Object"
    };

    public boolean
    ice_isA(String s)
    {
	return IceUtil.Arrays.search(__ids, s) >= 0;
    }

    public boolean
    ice_isA(String s, Ice.Current __current)
    {
	return IceUtil.Arrays.search(__ids, s) >= 0;
    }

    public String[]
    ice_ids()
    {
	return __ids;
    }

    public String[]
    ice_ids(Ice.Current __current)
    {
	return __ids;
    }

    public String
    ice_id()
    {
	return __ids[0];
    }

    public String
    ice_id(Ice.Current __current)
    {
	return __ids[0];
    }

    public static String
    ice_staticId()
    {
	return __ids[0];
    }

    public final void
    sayHello()
    {
	sayHello(null);
    }

    public final void
    shutdown()
    {
	shutdown(null);
    }

    public static IceInternal.DispatchStatus
    ___sayHello(Hello __obj, IceInternal.Incoming __in, Ice.Current __current)
    {
	__checkMode(Ice.OperationMode.Nonmutating, __current.mode);
	__obj.sayHello(__current);
	return IceInternal.DispatchStatus.DispatchOK;
    }

    public static IceInternal.DispatchStatus
    ___shutdown(Hello __obj, IceInternal.Incoming __in, Ice.Current __current)
    {
	__checkMode(Ice.OperationMode.Idempotent, __current.mode);
	__obj.shutdown(__current);
	return IceInternal.DispatchStatus.DispatchOK;
    }

    private final static String[] __all =
    {
	"ice_id",
	"ice_ids",
	"ice_isA",
	"ice_ping",
	"sayHello",
	"shutdown"
    };

    public IceInternal.DispatchStatus
    __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
	int pos = IceUtil.Arrays.search(__all, __current.operation);
	if(pos < 0)
	{
	    return IceInternal.DispatchStatus.DispatchOperationNotExist;
	}

	switch(pos)
	{
	    case 0:
	    {
		return ___ice_id(this, in, __current);
	    }
	    case 1:
	    {
		return ___ice_ids(this, in, __current);
	    }
	    case 2:
	    {
		return ___ice_isA(this, in, __current);
	    }
	    case 3:
	    {
		return ___ice_ping(this, in, __current);
	    }
	    case 4:
	    {
		return ___sayHello(this, in, __current);
	    }
	    case 5:
	    {
		return ___shutdown(this, in, __current);
	    }
	}
	if(IceUtil.Debug.ASSERT)
	{
	    IceUtil.Debug.Assert(false);
	}
	return IceInternal.DispatchStatus.DispatchOperationNotExist;
    }
}
